/*—————¦KSPE Shaders¦—————*/
//KSPE Renewed custom Color file

/*—————¦Agreement¦—————*/
/* Please read the agreement:

1.The modified color customization is designed to allow users to customize their own color style.
2.The modified color pack can only be used by the user himself, or by sharing the two "Color.txt" and "Setting.txt" files.
3.It is strictly forbidden to package and publish the modified color in its entirety, or to integrate it into any material and publish it. */

/*—————¦Modification¦—————*/
/* Modification Notes:
1. The option is "vec4 xxx =vec4(r,g,b,a)" Do not delete the symbols or letters in the options!
2. Adjust the rgb (red, green and blue) three-color ratio to adjust the color of light and shadow!
3. The alpha value of some options is invalid.
4. Remember to save the file first and then enter the game to see the effect after changing it. No change to 100 million without saving! */

/*—————¦Example¦—————*/
/* Modified example:

day light color
vec4 day_color = vec4(1.4,1.3,1.2,0.1);
change into:
day light color
vec4 day_color = vec4(1.0,0.0,0.0,0.0);
Change the day light color to pure red.

For more colors, please refer to the rgb color table! If the found color is a maximum of 255, please divide it by 128 and then fill in.
The color data should not exceed 2.0 as much as possible!

If there is a problem, please refer to "Help.txt" */

/*—————¦Content¦—————*/
//●Lighting
//●Shadow
//●Light source
//●Reflection
//●Water
//●Fog
//●Sky
//●Cloud
//●Sky
//●Weather
//●Other

/*—————¦Color Settting¦—————*/


//Light:
float rayleigh = 0.0;
vec3 dayc;
	 dayc.r = mix(1.00, 1.00, rayleigh);
	 dayc.g = mix(1.00, 0.75, rayleigh);
	 dayc.b = mix(1.00, 0.00, rayleigh);
//Daylight Color

vec3 nightc;
	 nightc.r = 1.0;
	 nightc.g = 1.0;
	 nightc.b = 1.0;
//Nightlight Color

vec3 duskc;
	 duskc.r = 1.00;
	 duskc.g = 0.58;
	 duskc.b = 0.00;
	 duskc *= 0.90;
//Dusklight Color

vec3 sunc;
	 sunc.r = 1.00;
	 sunc.g = 0.58;
	 sunc.b = 0.00;
	 sunc *= 0.65;
//Sunlight Color

vec3 underwaterc = vec3(0.0,0.91,0.98);
//Underwaterlight Color

vec3 underwaternightc = vec3(0.16,0.18,0.46);
//Underwater Nightlight Color

vec3 netherc = vec3(1.0,0.85,0.73);
//Netherlight Color


//External Light Color:
float torchWhiteBalance = 0.05;
//Overworld Torch White Balance

vec3 colorTorchlight = vec3(1.0,0.22,0.0); 
//Overworld External Light Color

float nethertorchWhiteBalance = 0.05;
//Nether Torch White Balance

vec3 nethercolorTorchlight = vec3(1.0,0.22,0.0); 
//Nether External Light Color

float underwatertorchWhiteBalance = 0.05;
//Underwater Torch White Balance

vec3 underwatercolorTorchlight = vec3(0.50,0.88,0.89)*1.25;  
//Underwater External Light Color


//Fog:
vec3 rainfogcolor = vec3(2.5,2.5,2.5);
//Rain Fog Color

vec3 netherfogcolor = vec3(0.65,0.42,0.25)*0.8;
//Nether Fog Color

vec3 underwaterfogcolor = vec3(0.29,0.76,0.58);
//Underwater Fog Color


//Shadow:
vec3 shadowcolor = vec3(0.38,0.4,0.44);
//Shadow color for dirlight, sides, and below

vec3 rainshadowcolor = vec3(0.75);
//Rain shadow color for dirlight, sides, and below

vec3 shadowcolor2 = vec3(0.38,0.4,0.44); 
//Shadow color for Player

vec3 rainshadowcolor2 = vec3(0.25);
//Rain shadow color for player


//Saturation:
float saturationstrength = 0.07; 
//Saturation Strength


//Grayscale:
float grayscalestrength = 0.1;
//Grayscale Strength


//Sun Beam:
vec3 sunbeamcolor = vec3(0.71,0.17,0.23)*1.41;
//Sun Beam Color

vec3 underwatersunbeamcolor = vec3(0.65,0.98,1.0)*2.0;
//Underwater Sun Beam Color

vec3 theendsunbeamcolor = vec3(0.4,0.0,0.7);
//The End Sun Beam Color


//Water:
float watertransparency = 0.5;
//Water Transparency

vec3 waterdaycolor = vec3(0.2,0.4,0.25);
//Water Color


//Sun Reflection:
vec3 sunreflection = vec3(1.0);
//Sun Reflection Color

vec3 dusksunreflection = vec3(0.71,0.17,0.23)*1.41;
//Dusk Sun Reflection

vec3 rainsunreflection = vec3(0.0);
//Rain Sun Reflection


//Sky Color:
vec4 s_color;
	 s_color.r = 0.30;
	 s_color.g = 0.595;
	 s_color.b = 0.70;	
     s_color.a = 1.0;
	 s_color *= 1.0;
//Sunrice And Dusk Sky Setting

vec4 d_color;
	 d_color.r = 0.00 ;
	 d_color.g = 0.3  ;
	 d_color.b = 0.999;
	 d_color.a = 1.0;
//Day Sky Setting

vec4 n_color;
	 n_color.r = 0.0 ;
	 n_color.g = 0.23;
	 n_color.b = 0.99;
	 n_color.a = 1.0;
//Night Sky Setting

vec4 gradSky = vec4(0.0,0.0,0.0,1.0);
//Gradien Sky Color

d_color = vec4(0.15,0.29,0.99,1.0);
//Day Sky Color

n_color = vec4(0.005,0.01,0.02,1.0)*0.025;
//Night Sky Color

s_color = vec4(0.19,0.35,0.7,1.0)*0.15;
//Sun And Dusk Sky Color

vec4 colorSkylight_rain = vec4(2.0, 2.0, 2.38, 4.0) * 0.25;
//Rain Sky Color

vec3 fogskycolor = vec3(0.5);
//Sky Fog Color

vec3 fogduskskycolor = vec3(1.0,0.2,0.0);
//Sky Dusk And Surice Fog Color


//Cloud
vec4 dayclouds = vec4(1.0);
//Day Clouds Color

vec4 nightclouds = vec4(0.05,0.1,0.2,1.0);
//Night Clouds Color

vec4 sunclouds = vec4(1.42,0.34,0.46,1.0);
//Sunrice And Dusk Clouds Color

vec4 rainclouds = vec4(0.1);
//Rain Clouds Color


//Sun
vec3 suncolor = vec3(0.6);
//Sun Color

vec3 sunduskcolor = vec3(0.81,0.27,0.03);
//Sun Sunrice And Dusk Color


//Star
vec3 starcolor = vec3(0.65,0.48,1.0);
//Star Color